/*
   PVII PagePack -Affinity by PVII
   Copyright 2013 Project Seven Development. All rights reserved. 
   ----------------------------------------------------
   www.projectseven.com
   
   ----------------------------------------------------
	Create PagePack Design Layouts
*/
function canAcceptCommand() {
	//allow all of the time
	var theRet = true;
	return theRet;
}

//handle the close
function cancelThis() {
   window.close();
}

//display the help file
function displayHelp(){
	var theHelpFile;
	theHelpFile = dw.getConfigurationPath() + '/ExtensionsHelp/ProjectSeven/PPAffinity/Affinity_help.htm';
	dreamweaver.browseDocument(theHelpFile);
}
//display the help file
function displayMoreDesigns(){
	var theHelpFile;
	theHelpFile='http://www.projectseven.com/products/templates/index.htm';
	dreamweaver.browseDocument(theHelpFile);
}

// ----------------- UI Support -----------------------

//init the settings
function initializeUI() {
	var theStatus=true;
	// check for DMM
	if(!checkForDMM()){
		theStatus = false;
	}
	
	if(theStatus){
		//populate the style/theme dropdown listing
		if(!popTheStyleThemes()){
			theStatus = false;
		}
	}
	
	if(theStatus){
		// just set the preview thumbnail
		handleThePreview();
	}else{
		//close window
		cancelThis();
	}
}


// ----------------- Preview support -------------------

//handle the thumbnail preview for selected lyaout
function handleThePreview(){
	var k,n,theList=document.forms[0].theLayouts,thumbName='thumb_';
	k=theList.selectedIndex;
	n=parseInt(theList.options[k].value,10);
		
	thumbName=thumbName+n;

	theList=document.forms[0].uStyleType;
	//get the selected menu style
	var x=theList.selectedIndex;
	var tS=theList.options[x].text;  // folder name

	var thePath=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/assets/themes/"+tS+"/thumbs/"+thumbName+".jpg";
	
	
	//build the path to the thumbnail for this layout
	//var thePath=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/thumbs/"+thumbName+".jpg";
	if(DWfile.exists(thePath)){
		// get the preview image
		var theImg=getThumbObj();
		if(theImg){
			theImg.src=thePath;
		}
	}
}

function getThumbObj(){
	var i,obj,theImg=document.getElementsByTagName("IMG");
	for(i=0;i<theImg.length;i++){
		if(theImg[i].id&&theImg[i].id=='thePreview'){
			obj=theImg[i];
			break;
		}
	}
	return obj;
}


// **************** create the PagePack Page ***********************

function createIt(){
	var i,n,k,thePage,theTo,theFrom,basePage='layout-0',staticMenu=false,sm,pM,themeNum,retVal;
	
	// get the style theme
	var theList=document.forms[0].uStyleType;
	//get the selected menu style
	var x=theList.selectedIndex;
	var tS=theList.options[x].text;  // folder name - 01-Affinity
	
	// theme number is integer
	themeNum=parseInt(tS,10); 

	var thePath=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/assets/themes/"+tS;
	
	
	// get the selected page layout - layout-1-01.htm , p7affinity-1_01.css
	theList=document.forms[0].theLayouts;
	k=theList.selectedIndex;
	n=theList.options[k].value;
		basePage='layout-'+themeNum+'-0'+n+'.htm';
	if(k>8){
		basePage='layout-'+themeNum+'-'+n+'.htm';
	}
		
	// -get the path and filename to save as
	var theBaseFolder,fileUrl = getTheFileName();
	if(fileUrl && fileUrl.length>4){
		//get the folder path to the current file
		k=fileUrl.lastIndexOf("/");
		theBaseFolder=fileUrl.substring(0,k);
		//alert('the Base folder:\n'+theBaseFolder);
	}else{
		return;
	}
	
	
	// build source base page name
	thePage=basePage;
	// get source assets folder
	var thePackPath=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/assets/themes/"+tS+'/';

	theFrom=thePackPath+thePage;
	theTo=fileUrl;
	// move the actual page -allow overwrite
	if(!moveTheFile(theFrom,theTo,true)){
		return;
	}
	
	
	
	// move the Global Fireworks files
	theFrom= dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/Fireworks";
	theTo=theBaseFolder+"/Fireworks";
	moveTheFiles(theFrom,theTo,1);
	
	// ready to move asset files, first create folder (needed for MX)
	var theFolder=theBaseFolder+"/p7affinity";
	DWfile.createFolder(theFolder);
	// move the style sheet -build the sheet name -p7affinity-1_01.css

	if(theList.selectedIndex>8){
		thePage='p7affinity-'+themeNum+'_'+n+'.css';
	}else{
		thePage='p7affinity-'+themeNum+'_0'+n+'.css';
	}
	
	// special over-rides
	/*
	// boardroom
	if(themeNum==3){
		thePage='p7affinity-3.css';
	}
	*/
	
	// full over-ride for themes greater than 2
	if(themeNum>2){
		thePage='p7affinity-'+themeNum+'.css';
	}

	// move css file
	theFrom=thePackPath+thePage;
	theTo=theFolder+"/"+thePage;
	//if(!moveTheFile(theFrom,theTo,false)){
	//	return;
	//}
	// now allow missing style sheet, in case we are using the special /sheets folder
	moveTheFile(theFrom,theTo,false);
	
	// move any special style sheets -the theme/sheets folder
	var theSheetPath=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/assets/themes/"+tS+'/sheets';
	theFrom= theSheetPath;
	theTo=theFolder;
	moveTheFiles(theFrom,theTo,1);
	
	
	// move the theme images
	theFrom= thePackPath+'images';
	theTo=theFolder+'/img';
	moveTheFiles(theFrom,theTo,1);
	
	
	var theBasePath=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/assets/";
	
	// move the Print style sheet
	thePage='p7affinity_print.css';
	theFrom=theBasePath+thePage;
	theTo=theFolder+"/"+thePage;
	moveTheFile(theFrom,theTo,1);
	
	// move the Design Time style sheet
	thePage='p7affinity-DT.css';
	theFrom=theBasePath+thePage;
	theTo=theFolder+"/"+thePage;
	moveTheFile(theFrom,theTo,1);
	

	// move the global image assets
	theFrom= theBasePath+"art";
	theTo=theBaseFolder+"/art";
	moveTheFiles(theFrom,theTo,1);
	
	
	// move ehc script file into site if needed
	// move core files 
	theFrom=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/EHCStyles/CoreFiles/p7ehc";
	theTo=theBaseFolder+'/p7ehc';
	moveTheFiles(theFrom,theTo,1);
	
	// 
	


	// ---------------- Drop Menu magic files -----------------------------
	
	var theCorePath=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/DMMStyles/CoreFiles";
	
	// move core files
	theFrom=theCorePath+"/p7dmm";
	theTo=theBaseFolder+'/p7dmm';
	moveTheFiles(theFrom,theTo,1);
	
	// move any core file sub img folder
	theFrom=theCorePath+"/p7dmm/img";
	theTo=theBaseFolder+'/p7dmm/img';
	moveTheFiles(theFrom,theTo,1);
	
	var theToPath=theBaseFolder+'/p7dmm';
	//var thePath=dreamweaver.getConfigurationPath()+'/Shared/Studio VII/DMMStyles/01-Affinity/p7dmm';
	thePath=dreamweaver.getConfigurationPath()+'/Shared/Studio VII/DMMStyles/'+tS+'/p7dmm';
	
	
	// move files inisde the styleName/p7dmm folder
	if(moveTheFiles(thePath,theToPath,0)){
		retVal=true;
		
		// move the p7dmm/img folder
		theFrom=thePath+"/img";
		theTo=theToPath+"/img";
		moveTheFiles(theFrom,theTo,1);
	}
	
	
	// --------------- end DMM files --------------------------------------


	//lastly, open the new page
	dreamweaver.openDocument(fileUrl);
	//lastly, update the site panel
	if(site.canRefresh('local')){
		site.refresh('local');
	}
	//close this interface
	MM.commandReturnValue = "";
	window.close();
	
}

// move the file, ov=true allow overwrite
function moveTheFile(theFrom,theTo,ov){
	var ret=true;
	if(ov || !DWfile.exists(theTo)){
		//add it to the site
		if(!DWfile.copy(theFrom, theTo)){
			alert('Could not copy PagePack File:'+theFrom+'\n\ntarget:'+theTo);
			ret=false;
		}
	}
	return ret;
}

//thePath=the full path of the source FROM folder 
//theF =the full path of the destination TO folder
//theFlag 0=trap error if no files exist 1=no trap
function moveTheFiles(thePath,theF,theFlag){
	var i,retVal=true;
	var theFileList ="";
	var theFileName ="";
	var theMask = "";
	var theTest,theFrom,theTo;
	//first, get the current page site info
	var theDocPath = dreamweaver.getDocumentPath("document");
	var theSiteRoot = dreamweaver.getSiteRoot();
	var theFolder= theF;
	
	// --- move all files in this folder ----
	theMask = "*.*";
	theFileList = DWfile.listFolder(thePath + "/" + theMask, "files");
	//be sure that there are files in this folder
	if(theFileList && theFileList.length>0){
		//create the folder, if necessary
		//alert('creating folder:'+theFolder);
		theTest = DWfile.createFolder(theFolder);
		//move the files -do not over-write
		for(i=0;i<theFileList.length;i++){
			//set to and from paths
			theFrom = thePath+"/"+theFileList[i];
			theTo = theF + '/' + theFileList[i];
			//check if the file is already there
			if(!DWfile.exists(theTo)){
				//add it to the site
				if(!DWfile.copy(theFrom, theTo)){
					alert('Could not copy Style and support file:\n\nsource:'+theFileList[i]+'\n\ntarget:'+theTo);
				}
			}
		}
	}else{
		//run only if flag is set to 0 (allows empty img folder)
		if(theFlag===0){
			alert('Could not find the source files! \n\nNo sub folder files for:\n-'+thePath);
			retVal = false;
		}
	}
	
	return retVal;
}

// --------------- support functions ------------------------------

//get the Save As filename
function getTheFileName(){
	var k,fileUrl='',retVal='',theStat=true;
	fileUrl = browseForFileURL("save",'',false,false);
	if(!fileUrl || fileUrl==''){
		return false;
	}
	//check for a file type
	k = fileUrl.lastIndexOf(".");
	var j=fileUrl.lastIndexOf("/");
	//add .htm extenison if no extension is typed in
	if(k==-1 || j>k){
		//fileUrl+='.htm';
		fileUrl+='.'+getTheDefDocType();
	}
	//set up if 
	if(fileUrl && fileUrl.length>4){
		retVal=fileUrl;
	}
	return retVal;
}

//get default doc type extension
function getTheDefDocType(){
	var i,theFileType='htm',h,sS,tA;
	var tDefType=dreamweaver.getPreferenceString("New Document Preferences","Default Document Type","HTML");
	var dD=DWfile.read(dreamweaver.getConfigurationPath()+"/DocumentTypes/MMDocumentTypes.xml");
	var reg1=eval('/id="'+tDefType+'[^>]*>/;');
	var osType=(navigator.platform != "Win32")?'macfileextension':'winfileextension';

	//if dw8 and default is html, get the extension from the registry
	if(tDefType=="HTML" && dreamweaver.appVersion && parseFloat(dreamweaver.appVersion)>=8.0){
		theFileType=dreamweaver.getPreferenceString("New Document Preferences","Default HTML Extension","htm");
	}else{
		//alert(tDefType);
		if(tDefType){
			h=dD.match(reg1);
			//alert(h);
			if(h&&h[0]){
				tA=h[0].split('"');
				//alert(tA);
				for(i=0;i<tA.length;i++){
					if(tA[i].indexOf(osType)>-1){
						sS=tA[i+1].split(',');
						if(sS&&sS[0]){
							theFileType=sS[0];
						}
						break;
					}
				}
			}
		}
	}
	return theFileType;
}


function checkForDMM(){
	var retVal=false;
	if(DWfile.exists(dreamweaver.getConfigurationPath()+"/Commands/P7_DMM_edit.js")&&DWfile.exists(dreamweaver.getConfigurationPath()+"/commands/P7_DMM_tv.js")){
			retVal=true;
	}else{
		alert('Required Assets Verfification Error!\n\nThis PagePack requires that the Drop Menu Magic system is installed.\n\nInstall the Drop Menu Magic system, re-start Dreamweaver and try again.');
	}
return retVal;
}



// ------------ Produce Available Styles Listing ------------------------

//produce the available style themes select list
function popTheStyleThemes(){
	var i,retVal=false;
	var thePath = dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/assets/themes";
	var theFileList = DWfile.listFolder(thePath,"directories");
	if(theFileList && theFileList.length>0){
		//sort
		theFileList.sort();
		retVal=true;
		//populate the list
		popTheSelect(theFileList, document.forms[0].uStyleType);
		//alert(document.forms[0].theStyle.outerHTML);
	}else{
		alert('Could not locate default Component Styles!\n\nPlease re-install this extension.');
		
	}
	return retVal;
}

// populate the select list -
function popTheSelect(theArray, theSelectList, defOpt) {
	var z,zz,k=0;
	theSelectList.options.length = 0;
	if(defOpt){
		k=1;
		theSelectList.options[0]=new Option(defOpt);
	}
	for (var i=0;i<theArray.length;i++) {
		//remove CoreFiles from this listing
		if(theArray[i]!="CoreFiles"){
			
			z=parseInt(theArray[i],10);
			theSelectList.options[k] = new Option(theArray[i]);
/*
			// build the style sheet name as value
			z=(z<10)?'0'+z:z;
			//zz="p7DMM"+z;
			zz='p7affinity-'+z;
			
			// p7affinity-1_01.css
			
*/
			
			//alert(zz);
			// juat use the style theme number (integer)
			theSelectList.options[k].value=z;
			k++;
		}
	}
	theSelectList.selectedIndex = 0;
}


//return the full path to the selected style theme folder name
// f = 1 = append full path with sub folder:
function getStyleFolder(f){
	var k,x,tS='',thePath,theFileList,theSfolder,theList=document.forms[0].uStyleType;
	//get the selected menu style
	x=theList.selectedIndex;
	tS=theList.options[x].text;  // folder name
	
	
	
	
	thePath=dreamweaver.getConfigurationPath()+"/Shared/Studio VII/PPAffinity/assets/themes/"+tS;

	// 
	if(f&&f>0){
		thePath=thePath+'/p7dmm';
	}
	return thePath;
}





